//+------------------------------------------------------------------+
//|                                                  Min_max_vol.mq5 |
//|                                     Copyright 2021, prostotrader |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, prostotrader"
#property link      "https://www.mql5.com"
#property version   "1.00"
//---
bool is_book;
struct BOOK_DATA
{
  double s_price;
  long s_volume;
  int s_pos;
  int s_mem;
  bool s_flag;
  double b_price;
  long b_volume;
  int b_pos;
}book_data;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   is_book = MarketBookAdd(Symbol());
   if(is_book == false)
   {
     Print("No book added!");
     return(INIT_FAILED);
   }
   ObjectCreate(ChartID(),"MM_1",OBJ_LABEL,0,0,0);
   ObjectCreate(ChartID(),"MM_2",OBJ_LABEL,0,0,0);
      
   ObjectSetInteger(ChartID(),"MM_1",OBJPROP_XDISTANCE,5);
   ObjectSetInteger(ChartID(),"MM_2",OBJPROP_XDISTANCE,5);
       
   ObjectSetInteger(ChartID(),"MM_1",OBJPROP_YDISTANCE,15);
   ObjectSetInteger(ChartID(),"MM_2",OBJPROP_YDISTANCE,30);
         
   ObjectSetInteger(ChartID(),"MM_1",OBJPROP_COLOR,clrWhite);
   ObjectSetInteger(ChartID(),"MM_2",OBJPROP_COLOR,clrWhite);
   ChartRedraw();
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
    if(is_book == true) MarketBookRelease(Symbol());
    ObjectDelete(ChartID(),"MM_1");
    ObjectDelete(ChartID(),"MM_2");
    ChartRedraw();
  }
//+------------------------------------------------------------------+
//| Get stakan function                                              |
//+------------------------------------------------------------------+
bool GetBook(const string aSymbol)
{
  MqlBookInfo book_price[]; 
  if(MarketBookGet(aSymbol, book_price) == true)//getBook )
  {
    int size = ArraySize(book_price);
    if(size > 0)
    {
      book_data.s_flag = false;
      book_data.s_pos = -1;
      book_data.s_volume = LONG_MIN;
      book_data.b_pos = -1;
      book_data.b_volume = LONG_MIN;
      
      for(int i = 0; i < size; i++)
      {
        if(book_price[i].type == BOOK_TYPE_SELL) 
        {
          if(book_price[i].volume > book_data.s_volume)
          {
            book_data.s_price = book_price[i].price;
            book_data.s_volume = book_price[i].volume;
            book_data.s_pos = i;
          }
        }
        else
        if(book_price[i].type == BOOK_TYPE_BUY) 
        {
          if(book_data.s_flag == false)
          {
             book_data.s_mem = i;
             book_data.s_flag = true;
          }   
          if(book_price[i].volume > book_data.b_volume)
          {
            book_data.b_price = book_price[i].price;
            book_data.b_volume = book_price[i].volume;
            book_data.b_pos = i;
          }
        }
      }
      book_data.s_pos = book_data.s_mem - 1 - book_data.s_pos;
      book_data.b_pos = book_data.b_pos - book_data.s_mem;  
      return(true);
    }
  }
  return(false);
}
//+------------------------------------------------------------------+
//| BookEvent function                                               |
//+------------------------------------------------------------------+
void OnBookEvent(const string &symbol)
  {
    if(symbol == Symbol())
    {
      if(GetBook(Symbol()) == true)
      {
        ObjectSetString(ChartID(),"MM_1",OBJPROP_TEXT, "Sell max pos = " + string(book_data.s_pos));
        ObjectSetString(ChartID(),"MM_2",OBJPROP_TEXT, "Buy max pos = " + string(book_data.b_pos)); 
        ChartRedraw();
      }
    }
  }
//+------------------------------------------------------------------+
